︠b1c0e2c3-577b-4798-aefa-4e0802dd991fs︠
#Question 6
S1=[[1,0,1],[0,1,0],[0,0,1],[1,1,0],[0,1,1],[1,0,0],[1,1,1],[0,0,0],
    [0,0,1],[1,0,0],[1,1,0],[0,1,0],[0,0,0],[1,1,1],[1,0,1],[0,1,1]]
S2=[[1,0,0],[0,0,0],[1,1,0],[1,0,1],[1,1,1],[0,0,1],[0,1,1],[0,1,0],
    [1,0,1],[0,1,1],[0,0,0],[1,1,1],[1,1,0],[0,1,0],[0,0,1],[1,0,0]]
︡02ffaf70-53a1-46f8-a5b6-d8ec05f13fda︡{"done":true}
︠89278342-3ca1-43c1-9a21-ef3ad3992e38s︠
def Expander(L): #Expands a string from 6 bits to 8 bits for SDES
    if not len(L)==6:
        print "Wrong length"
        return 0
    R = [L[0],L[1],L[3],L[2],L[3],L[2],L[4],L[5]]
    return R
︡88ab28c2-fa3b-49ea-bd36-a7265a62d896︡{"done":true}︡
︠d098b24e-60c3-4fd1-a0fb-6b88bc3a79b9s︠
def xor(L,M):  #performs a binary xor (addition) of the two strings L,M
    if not len(L)==len(M):
        print "Strings have different lengths"
        return 0
    return [sum(a)%2 for a in zip(L,M)]
︡ff5f1a0f-7c56-42c4-94ba-89d9bedfcdbb︡{"done":true}︡
︠8473c344-865b-4647-a408-b9e9acdd1eecs︠
def roundkey(K,i): #Return the 8 bit key for round i from the master 9-bit key
    if i==1 or i==2:
        return K[i-1:i+7]
    else:
        return K[i-1:10]+K[0:i-2]
︡bc51278b-4c6c-4c5c-8372-8f41c9a63318︡{"done":true}︡
︠206c8317-267b-4a20-b4df-c4f8872a44f3s︠
def bin2int(L): #convert binary list to integer
    sum=0
    l=len(L)-1
    for i in [0..l]:
        if L[i]==1:
            sum+=2^(l-i)
    return sum
︡ba358072-9b2c-4018-941c-9be13ab6d6e1︡{"done":true}︡
︠cd7813cb-a247-4d1b-a4b8-bb543fef06c4s︠
def split(M):  #Splits the list M into two equal halves, used several times in SDES algorithm
    if len(M)%2==1:
        print "Wrong Message Length"
    return (M[0:len(M)/2],M[len(M)/2:len(M)])
︡69d465c6-d91f-43c8-97cd-d2cfd765f740︡{"done":true}︡
︠9fdefae7-d4e5-4476-9cb6-b9205936233cs︠
def SDESf(R,Ki): #Performs the function f that is used in the encryption of SDES
    E=Expander(R)
    Temp=xor(E,Ki)
    (rhalf,lhalf)=split(Temp)
    return S1[bin2int(rhalf)]+S2[bin2int(lhalf)]
︡20d5c584-13cf-42f6-a22b-11fd9af2dfc7︡{"done":true}︡
︠25e4e515-64c3-4b8a-bbf6-96ca9dfa4208s︠
def SDESround(M,Kr):  #Performs one round of SDES using the roundkey Kr
    (L1,R1)=split(M)
    L2=R1
    R2 = xor(SDESf(R1,Kr),L1)
    return L2+R2
︡cd1ac3a2-40ac-45dd-9631-7bd46fdb960e︡{"done":true}︡
︠39bad1f1-c30e-49c6-832a-1b55496a0e37s︠
def SDES(M,K,r):  #Performs SDES on M with the key K using r rounds.
    for i in [1..r]:
        rkey=roundkey(K,i)
        M=SDESround(M,rkey)
        print "Round:",i,M
    return M
︡1d12a620-8273-4c8e-95e0-4fa23aeb4c34︡{"done":true}︡
︠9fc984bf-7ba4-455a-941c-34f3ffb74c89s︠
#Example:
SDES([1,0,0,1,0,0,1,0,0,1,0,0],[1,1,1,1,1,1,1,1,0],7)
︡d53bc4a3-1b4f-4e7a-b617-21ab17e394a5︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 996, in execute\n    exec compile(block+'\\n', '', 'single') in namespace, locals\n  File \"\", line 1, in <module>\nNameError: name 'SDES' is not defined\n"}︡{"done":true}︡









